C      Compute erf(1), i.e. integral of 2/sqrt(pi) * exp(-x*x) from 0 to 1.0
C
      EXTERNAL FUNC
      DOUBLE PRECISION A,B,RESULT,ABSERR,RESABS,RESASC,PI
C
      A = 0.0D0
      B = 1.0D0
      PI = 4.0D0*ATAN(1.0D0)
      CALL DQK15(FUNC,A,B,RESULT,ABSERR,RESABS,RESASC)
      WRITE(*,*) ' DQK15 ESTIMATE OF ERF(1)'
      WRITE(*,*) ' 2.0/SQRT(PI)*RESULT'
      WRITE(*,'(3X,D20.12,3X,D20.12)') 2.0D0/SQRT(PI)*RESULT,ABSERR
C
      WRITE(*,*)
      WRITE(*,*) 'REFERENCE RESULTS COMPUTED ON IBM PC/AT '
      WRITE(*,*) '    0.842700792950E+00     0.828974787422E-14'
      STOP
      END
C      
      DOUBLE PRECISION FUNCTION FUNC(X)
        DOUBLE PRECISION X
        FUNC = EXP(-X*X)
        RETURN
      END
