C SAMPLE PROGRAM FOR FZERO
C
      REAL     B, C, AE, RE
      EXTERNAL F
C
      B   = 2.0
      C   = 3.0
      AE  = 1.E-6
      RE  = 1.E-6
      WRITE (*,*) ' INITIAL INTERVAL: ', B, C
      WRITE (*,*) ' TOLERANCES:       ', AE, RE
C
      CALL FZERO (F, B, C, C, RE, AE, IFLAG)
C
      WRITE (*,*)
      WRITE (*,*) 'FZERO RESULTS'
      IF (IFLAG .NE. 1) WRITE (*,*) ' ERROR CODE =', IFLAG
      WRITE (*,*) ' ESTIMATE OF ZERO =', B
      WRITE (*,*) ' FUNCTION VALUE =  ', F(B)
C
      WRITE (*,*)
      WRITE (*,*) 'REFERENCE RESULTS FROM IBM PC/AT'
      WRITE (*,*) ' ESTIMATE OF ZERO =    2.09455'    
      WRITE (*,*) ' FUNCTION VALUE =    -0.174897E-05'
C
      STOP
      END
C
C
      REAL FUNCTION F(X)
      REAL X
C
      F = X * (X*X-2.0) - 5.0
C
      RETURN
      END
